<template>
  <NuxtLayout :name="'dashboard'">
    <div class="flex justify-evenly container p-8">
      <div class="p-2 my-12 rounded-lg lg:w-1/3 xl:1/2 h-fit border-solid border-slate-300 border-2">
        <DynamicForm :fields="fields" :formTitle="formTitle" :submitName="submitName" :onSubmit="onSubmit" />
      </div>
    </div>
  </NuxtLayout>
</template>
  
<script lang="ts">

definePageMeta({
  middleware: ["auth"],
});

interface formTemplate {
  title: string;
  description: string;
}

export default {
  data() {
    return {
      formTitle: "Create New Application",
      submitName: "Save",
      isLoading: false,
      form: {
        title: '',
        description: '',
      },
      fields: [
        { id: "description", name: "Description", type: "text", value: "" },
      ],
    };
  },
  methods: {
    onSubmit(data: formTemplate) {
      this.isLoading = true;
      const toastStore = useToastStore();
      const accessToken: string = localStorage.getItem("access_token")!;

      // const formData = new FormData();
      // formData.append('file', this.form.file);

      this.$api
        .post(`/application`,
          data,
          {
            headers: {
              'Accept': 'application/json',
              'Authorization': `Bearer ${accessToken}`,
            },
          }
        )
        .then((response) => {
          console.log(response);
          toastStore.showToast('success', "Data stored successfully");
          this.$router.replace("/application");
        })
        .catch((error) => {
          console.log(error);
          const detail = error.response.data.detail;
          let message = "";
          if (detail[0].msg) {
            message = detail[0].msg;
          } else {
            message = detail;
          }
          toastStore.showToast(message, 'danger');
        }).finally(() => {
          this.isLoading = false;
        })
    },
    // onFileChange(event: Event) {
    //   const input = event.target as HTMLInputElement
    //   if (input.files && input.files.length > 0) {
    //     this.form.file = input.files[0]
    //   } else {
    //     this.form.file = null
    //   }
    // },
  },
};
</script>
  